package net.scott.minecraftvillagerdimensionmod.block;

import com.terraformersmc.terraform.sign.api.block.*;
import net.fabricmc.fabric.api.object.builder.v1.block.FabricBlockSettings;
import net.minecraft.block.*;
import net.minecraft.class_1747;
import net.minecraft.class_1792;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2269;
import net.minecraft.class_2323;
import net.minecraft.class_2349;
import net.minecraft.class_2354;
import net.minecraft.class_2378;
import net.minecraft.class_2397;
import net.minecraft.class_2440;
import net.minecraft.class_2465;
import net.minecraft.class_2473;
import net.minecraft.class_2482;
import net.minecraft.class_2498;
import net.minecraft.class_2510;
import net.minecraft.class_2527;
import net.minecraft.class_2533;
import net.minecraft.class_2555;
import net.minecraft.class_2960;
import net.minecraft.class_3619;
import net.minecraft.class_4719;
import net.minecraft.class_4970;
import net.minecraft.class_5793;
import net.minecraft.class_5794;
import net.minecraft.class_7923;
import net.minecraft.class_8177;
import net.minecraft.class_8813;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;
import net.scott.minecraftvillagerdimensionmod.particle.ModParticleTypes;
import net.scott.minecraftvillagerdimensionmod.world.ModConfiguredFeatures;

import java.util.Optional;

public class ModBlocks {

    public static final class_2248 EMERALD_TORCH = registerBlock("emerald_torch", new class_2527(
            ModParticleTypes.EMERALD_FLAME,
            class_4970.class_2251.method_9637().method_9634().method_9618().method_9631(state -> 14).method_9626(class_2498.field_11547).method_50012(class_3619.field_15971)
    ));
    public static final class_2248 WALL_EMERALD_TORCH = registerBlock("wall_emerald_torch",new class_2555(
                    ModParticleTypes.EMERALD_FLAME,
                    class_4970.class_2251.method_9637()
                            .method_9634()
                            .method_9618()
                            .method_9631(state -> 14)
                            .method_9626(class_2498.field_11547)
                            .method_16228(EMERALD_TORCH)
                            .method_50012(class_3619.field_15971)
            )
    );

    public static final class_2248 ANCIENT_GEMSTONE_ORE = registerBlock("ancient_gemstone_ore",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10442))); // Will have to use create and set the block settings
    // .requiresTool().strength(3.0F, 3.0F) ... something like this?
    public static final class_2248 DEEPSLATE_ANCIENT_GEMSTONE_ORE = registerBlock("deepslate_ancient_gemstone_ore",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_29029)));
    public static final class_2248 ANCIENT_GEMSTONE_BLOCK = registerBlock("ancient_gemstone_block",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10201)));

    public static final class_2248 PILLAGERITE_ORE = registerBlock("pillagerite_ore",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10442)));
    public static final class_2248 DEEPSLATE_PILLAGERITE_ORE = registerBlock("deepslate_pillagerite_ore",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_29029)));
    public static final class_2248 PILLAGERITE_BLOCK = registerBlock("pillagerite_block",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10201)));

    public static final class_2248 MAGICITE_ORE = registerBlock("magicite_ore",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10442)));
    public static final class_2248 DEEPSLATE_MAGICITE_ORE = registerBlock("deepslate_magicite_ore",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_29029)));
    public static final class_2248 MAGICITE_BLOCK = registerBlock("magicite_block",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10201)));

    //************************************* ROWAN WOOD *******************************************************************//
    public static final class_2248 ROWAN_LOG = registerBlock("rowan_log",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10431).method_9632(1f)));
    public static final class_2248 ROWAN_WOOD = registerBlock("rowan_wood",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10126).method_9632(1f)));
    public static final class_2248 STRIPPED_ROWAN_LOG = registerBlock("stripped_rowan_log",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10519).method_9632(1f)));
    public static final class_2248 STRIPPED_ROWAN_WOOD = registerBlock("stripped_rowan_wood",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10250).method_9632(1f)));

    public static final class_2248 ROWAN_PLANKS = registerBlock("rowan_planks",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10161).method_9632(1f)));
    public static final class_2248 ROWAN_LEAVES = registerBlock("rowan_leaves",
            new class_2397(class_4970.class_2251.method_9630(class_2246.field_10503).method_9632(0.3f).method_22488()));
    public static final class_2248 ROWAN_BERRY_LEAVES = registerBlock("rowan_berry_leaves",
            new class_2397(class_4970.class_2251.method_9630(class_2246.field_10503).method_9632(0.3f).method_22488()));

    public static final class_2960 ROWAN_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entity/signs/rowan");
    public static final class_2960 ROWAN_HANGING_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entity/signs/hanging/rowan");
    public static final class_2960 ROWAN_HANGING_GUI_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "textures/gui/hanging_signs/rowan");

    public static final class_2248 STANDING_ROWAN_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "rowan_standing_sign"),
            new TerraformSignBlock(ROWAN_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_10231)));
    public static final class_2248 WALL_ROWAN_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "rowan_wall_sign"),
            new TerraformWallSignBlock(ROWAN_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_10391)));

    public static final class_2248 HANGING_ROWAN_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "rowan_hanging_sign"),
            new TerraformHangingSignBlock(ROWAN_HANGING_SIGN_TEXTURE,ROWAN_HANGING_GUI_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_40264)));
    public static final class_2248 WALL_HANGING_ROWAN_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "rowan_wall_hanging_sign"),
            new TerraformWallHangingSignBlock(ROWAN_HANGING_SIGN_TEXTURE,ROWAN_HANGING_GUI_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_40274)));

    public static final class_5794 ROWAN_FAMILY = class_5793.method_33468(ModBlocks.ROWAN_PLANKS)
            .method_33483(ModBlocks.STANDING_ROWAN_SIGN, ModBlocks.WALL_ROWAN_SIGN)
            .method_33484("wooden").method_33487("has_planks").method_33481();

    public static final class_2248 ROWAN_STAIRS = registerBlock("rowan_stairs",
            new class_2510(ModBlocks.ROWAN_PLANKS.method_9564(),class_4970.class_2251.method_9630(class_2246.field_10563)));
    public static final class_2248 ROWAN_SLAB = registerBlock("rowan_slab",
            new class_2482(class_4970.class_2251.method_9630(class_2246.field_10119)));

    public static final class_2248 ROWAN_BUTTON = registerBlock("rowan_button",
            new class_2269(class_8177.field_42823, 10, class_4970.class_2251.method_9630(class_2246.field_10057)));
    public static final class_2248 ROWAN_PRESSURE_PLATE = registerBlock("rowan_pressure_plate",
            new class_2440(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10484)));

    public static final class_2248 ROWAN_FENCE = registerBlock("rowan_fence",
            new class_2354(class_4970.class_2251.method_9630(class_2246.field_10620)));
    public static final class_2248 ROWAN_FENCE_GATE = registerBlock("rowan_fence_gate",
            new class_2349(class_4719.field_21676, class_4970.class_2251.method_9630(class_2246.field_10188)));
    public static final class_2248 ROWAN_DOOR = registerBlock("rowan_door",
            new class_2323(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10201).method_22488()));
    public static final class_2248 ROWAN_TRAPDOOR = registerBlock("rowan_trapdoor",
            new class_2533(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10201).method_22488()));


    public static final class_2248 ROWAN_SAPLING = registerBlock("rowan_sapling",
            new class_2473(
                    new class_8813(
                            MinecraftVillagerDimensionMod.MOD_ID,
                            0.1F,
                            Optional.empty(),
                            Optional.empty(),
                            Optional.of(ModConfiguredFeatures.ROWAN_KEY),
                            Optional.empty(),
                            Optional.empty(),
                            Optional.empty()
                    ), class_4970.class_2251.method_9630(class_2246.field_10160)));

    //*******************************************************************************************************************//

    //************************************* JUNIPER WOOD *******************************************************************//
    public static final class_2248 JUNIPER_LOG = registerBlock("juniper_log",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10431).method_9632(1f)));
    public static final class_2248 JUNIPER_WOOD = registerBlock("juniper_wood",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10126).method_9632(1f)));
    public static final class_2248 STRIPPED_JUNIPER_LOG = registerBlock("stripped_juniper_log",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10519).method_9632(1f)));
    public static final class_2248 STRIPPED_JUNIPER_WOOD = registerBlock("stripped_juniper_wood",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10250).method_9632(1f)));

    public static final class_2248 JUNIPER_PLANKS = registerBlock("juniper_planks",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10161).method_9632(1f)));
    public static final class_2248 JUNIPER_LEAVES = registerBlock("juniper_leaves",
            new class_2397(class_4970.class_2251.method_9630(class_2246.field_10503).method_9632(0.3f).method_22488()));
    public static final class_2248 JUNIPER_BERRY_LEAVES = registerBlock("juniper_berry_leaves",
            new class_2397(class_4970.class_2251.method_9630(class_2246.field_10503).method_9632(0.3f).method_22488()));

    public static final class_2960 JUNIPER_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entity/signs/juniper");
    public static final class_2960 JUNIPER_HANGING_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entity/signs/hanging/juniper");
    public static final class_2960 JUNIPER_HANGING_GUI_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "textures/gui/hanging_signs/juniper");

    public static final class_2248 STANDING_JUNIPER_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "juniper_standing_sign"),
            new TerraformSignBlock(JUNIPER_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_10121)));
    public static final class_2248 WALL_JUNIPER_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "juniper_wall_sign"),
            new TerraformWallSignBlock(JUNIPER_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_10187)));

    public static final class_2248 HANGING_JUNIPER_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "juniper_hanging_sign"),
            new TerraformHangingSignBlock(JUNIPER_HANGING_SIGN_TEXTURE,JUNIPER_HANGING_GUI_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_40262)));
    public static final class_2248 WALL_HANGING_JUNIPER_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "juniper_wall_hanging_sign"),
            new TerraformWallHangingSignBlock(JUNIPER_HANGING_SIGN_TEXTURE,JUNIPER_HANGING_GUI_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_40272)));

    public static final class_5794 JUNIPER_FAMILY = class_5793.method_33468(ModBlocks.JUNIPER_PLANKS)
            .method_33483(ModBlocks.STANDING_JUNIPER_SIGN, ModBlocks.WALL_JUNIPER_SIGN)
            .method_33484("wooden").method_33487("has_planks").method_33481();

    public static final class_2248 JUNIPER_STAIRS = registerBlock("juniper_stairs",
            new class_2510(ModBlocks.JUNIPER_PLANKS.method_9564(),class_4970.class_2251.method_9630(class_2246.field_10563)));
    public static final class_2248 JUNIPER_SLAB = registerBlock("juniper_slab",
            new class_2482(class_4970.class_2251.method_9630(class_2246.field_10119)));

    public static final class_2248 JUNIPER_BUTTON = registerBlock("juniper_button",
            new class_2269(class_8177.field_42823, 10, class_4970.class_2251.method_9630(class_2246.field_10057)));
    public static final class_2248 JUNIPER_PRESSURE_PLATE = registerBlock("juniper_pressure_plate",
            new class_2440(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10484)));

    public static final class_2248 JUNIPER_FENCE = registerBlock("juniper_fence",
            new class_2354(class_4970.class_2251.method_9630(class_2246.field_10620)));
    public static final class_2248 JUNIPER_FENCE_GATE = registerBlock("juniper_fence_gate",
            new class_2349(class_4719.field_21676, class_4970.class_2251.method_9630(class_2246.field_10188)));
    public static final class_2248 JUNIPER_DOOR = registerBlock("juniper_door",
            new class_2323(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10201).method_22488()));
    public static final class_2248 JUNIPER_TRAPDOOR = registerBlock("juniper_trapdoor",
            new class_2533(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10201).method_22488()));

    public static final class_2248 JUNIPER_SAPLING = registerBlock("juniper_sapling",
            new class_2473(
                    new class_8813(
                            MinecraftVillagerDimensionMod.MOD_ID,
                            0.1F,
                            Optional.empty(),
                            Optional.empty(),
                            Optional.of(ModConfiguredFeatures.JUNIPER_KEY),
                            Optional.empty(),
                            Optional.empty(),
                            Optional.empty()
                    ), class_4970.class_2251.method_9630(class_2246.field_10394)));

    //*******************************************************************************************************************//

    //************************************* SYCAMORE WOOD *******************************************************************//
    public static final class_2248 SYCAMORE_LOG = registerBlock("sycamore_log",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10431).method_9632(1f)));
    public static final class_2248 SYCAMORE_WOOD = registerBlock("sycamore_wood",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10126).method_9632(1f)));
    public static final class_2248 STRIPPED_SYCAMORE_LOG = registerBlock("stripped_sycamore_log",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10519).method_9632(1f)));
    public static final class_2248 STRIPPED_SYCAMORE_WOOD = registerBlock("stripped_sycamore_wood",
            new class_2465(class_4970.class_2251.method_9630(class_2246.field_10250).method_9632(1f)));

    public static final class_2248 SYCAMORE_PLANKS = registerBlock("sycamore_planks",
            new class_2248(class_4970.class_2251.method_9630(class_2246.field_10161).method_9632(1f)));
    public static final class_2248 SYCAMORE_LEAVES = registerBlock("sycamore_leaves",
            new class_2397(class_4970.class_2251.method_9630(class_2246.field_10503).method_9632(0.3f).method_22488()));

    public static final class_2960 SYCAMORE_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entity/signs/sycamore");
    public static final class_2960 SYCAMORE_HANGING_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "entity/signs/hanging/sycamore");
    public static final class_2960 SYCAMORE_HANGING_GUI_SIGN_TEXTURE = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "textures/gui/hanging_signs/sycamore");

    public static final class_2248 STANDING_SYCAMORE_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "sycamore_standing_sign"),
            new TerraformSignBlock(SYCAMORE_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_10284)));
    public static final class_2248 WALL_SYCAMORE_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "sycamore_wall_sign"),
            new TerraformWallSignBlock(SYCAMORE_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_10401)));

    public static final class_2248 HANGING_SYCAMORE_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "sycamore_hanging_sign"),
            new TerraformHangingSignBlock(SYCAMORE_HANGING_SIGN_TEXTURE,SYCAMORE_HANGING_GUI_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_40265)));
    public static final class_2248 WALL_HANGING_SYCAMORE_SIGN = class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "sycamore_wall_hanging_sign"),
            new TerraformWallHangingSignBlock(SYCAMORE_HANGING_SIGN_TEXTURE,SYCAMORE_HANGING_GUI_SIGN_TEXTURE, class_4970.class_2251.method_9630(class_2246.field_40275)));

    public static final class_5794 SYCAMORE_FAMILY = class_5793.method_33468(ModBlocks.SYCAMORE_PLANKS)
            .method_33483(ModBlocks.STANDING_SYCAMORE_SIGN, ModBlocks.WALL_SYCAMORE_SIGN)
            .method_33484("wooden").method_33487("has_planks").method_33481();

    public static final class_2248 SYCAMORE_STAIRS = registerBlock("sycamore_stairs",
            new class_2510(ModBlocks.SYCAMORE_PLANKS.method_9564(),class_4970.class_2251.method_9630(class_2246.field_10563)));
    public static final class_2248 SYCAMORE_SLAB = registerBlock("sycamore_slab",
            new class_2482(class_4970.class_2251.method_9630(class_2246.field_10119)));

    public static final class_2248 SYCAMORE_BUTTON = registerBlock("sycamore_button",
            new class_2269(class_8177.field_42823, 10, class_4970.class_2251.method_9630(class_2246.field_10057)));
    public static final class_2248 SYCAMORE_PRESSURE_PLATE = registerBlock("sycamore_pressure_plate",
            new class_2440(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10484)));

    public static final class_2248 SYCAMORE_FENCE = registerBlock("sycamore_fence",
            new class_2354(class_4970.class_2251.method_9630(class_2246.field_10620)));
    public static final class_2248 SYCAMORE_FENCE_GATE = registerBlock("sycamore_fence_gate",
            new class_2349(class_4719.field_21676, class_4970.class_2251.method_9630(class_2246.field_10188)));
    public static final class_2248 SYCAMORE_DOOR = registerBlock("sycamore_door",
            new class_2323(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10201).method_22488()));
    public static final class_2248 SYCAMORE_TRAPDOOR = registerBlock("sycamore_trapdoor",
            new class_2533(class_8177.field_42823, class_4970.class_2251.method_9630(class_2246.field_10201).method_22488()));

    public static final class_2248 SYCAMORE_SAPLING = registerBlock("sycamore_sapling",
            new class_2473(
                    new class_8813(
                            MinecraftVillagerDimensionMod.MOD_ID,
                            0.1F,
                            Optional.empty(),
                            Optional.empty(),
                            Optional.of(ModConfiguredFeatures.SYCAMORE_KEY),
                            Optional.empty(),
                            Optional.empty(),
                            Optional.empty()
                    ), class_4970.class_2251.method_9630(class_2246.field_10394)));

    //*******************************************************************************************************************//

    private static class_2248 registerBlock(String name, class_2248 block)
    {
        registerBlockItem(name, block);
        return class_2378.method_10230(class_7923.field_41175, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, name), block);
    }

    private static class_1792 registerBlockItem(String name, class_2248 block){
        return class_2378.method_10230(class_7923.field_41178, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, name),
                new class_1747(block, new class_1792.class_1793()));
    }

    public static void registerModBlocks(){
        MinecraftVillagerDimensionMod.LOGGER.info("Registering ModBlocks for " + MinecraftVillagerDimensionMod.MOD_ID);
    }
}
