package net.scott.minecraftvillagerdimensionmod.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricTagProvider;
import net.minecraft.class_3489;
import net.minecraft.class_7225;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;

import java.util.concurrent.CompletableFuture;

public class ModItemTagProvider extends FabricTagProvider.ItemTagProvider {

    public ModItemTagProvider(FabricDataOutput output, CompletableFuture<class_7225.class_7874> completableFuture) {
        super(output, completableFuture);
    }

    @Override
    protected void method_10514(class_7225.class_7874 arg) {

        //************************************* ROWAN WOOD ****************************************************************//
        method_10512(class_3489.field_15537)
                .add(ModBlocks.ROWAN_PLANKS.method_8389());

        method_10512(class_3489.field_23212)
                .add(ModBlocks.ROWAN_LOG.method_8389())
                .add(ModBlocks.STRIPPED_ROWAN_LOG.method_8389())
                .add(ModBlocks.ROWAN_WOOD.method_8389())
                .add(ModBlocks.STRIPPED_ROWAN_WOOD.method_8389());
        //*******************************************************************************************************************//

        //************************************* JUNIPER WOOD ****************************************************************//
        method_10512(class_3489.field_15537)
                .add(ModBlocks.JUNIPER_PLANKS.method_8389());

        method_10512(class_3489.field_23212)
                .add(ModBlocks.JUNIPER_LOG.method_8389())
                .add(ModBlocks.STRIPPED_JUNIPER_LOG.method_8389())
                .add(ModBlocks.JUNIPER_WOOD.method_8389())
                .add(ModBlocks.STRIPPED_JUNIPER_WOOD.method_8389());

        //*******************************************************************************************************************//

        //************************************* SYCAMORE WOOD ****************************************************************//
        method_10512(class_3489.field_15537)
                .add(ModBlocks.SYCAMORE_PLANKS.method_8389());

        method_10512(class_3489.field_23212)
                .add(ModBlocks.SYCAMORE_LOG.method_8389())
                .add(ModBlocks.STRIPPED_SYCAMORE_LOG.method_8389())
                .add(ModBlocks.SYCAMORE_WOOD.method_8389())
                .add(ModBlocks.STRIPPED_SYCAMORE_WOOD.method_8389());
        //*******************************************************************************************************************//
        //************************************* ANCIENT GEMSTONE ************************************************************//
        method_10512(class_3489.field_42611)
                .add(ModItems.ANCIENT_GEMSTONE_SWORD);
        method_10512(class_3489.field_42612)
                .add(ModItems.ANCIENT_GEMSTONE_AXE );
        method_10512(class_3489.field_42615)
                .add(ModItems.ANCIENT_GEMSTONE_SHOVEL);
        method_10512(class_3489.field_42613)
                .add(ModItems.ANCIENT_GEMSTONE_HOE);
        method_10512(class_3489.field_42614)
                .add(ModItems.ANCIENT_GEMSTONE_PICKAXE);


        method_10512(class_3489.field_48297)
                .add(ModItems.ANCIENT_GEMSTONE_HELMET);
        method_10512(class_3489.field_48296)
                .add(ModItems.ANCIENT_GEMSTONE_CHESTPLATE);
        method_10512(class_3489.field_48295)
                .add(ModItems.ANCIENT_GEMSTONE_LEGGINGS);
        method_10512(class_3489.field_48294)
                .add(ModItems.ANCIENT_GEMSTONE_BOOTS);

        method_10512(class_3489.field_41890)
                .add(ModItems.ANCIENT_GEMSTONE_HELMET, ModItems.ANCIENT_GEMSTONE_CHESTPLATE, ModItems.ANCIENT_GEMSTONE_LEGGINGS, ModItems.ANCIENT_GEMSTONE_BOOTS);
        //*******************************************************************************************************************//

        //************************************* PILLAGERITE ************************************************************//
        method_10512(class_3489.field_42611)
                .add(ModItems.PILLAGERITE_SWORD);
        method_10512(class_3489.field_42612)
                .add(ModItems.PILLAGERITE_AXE );
        method_10512(class_3489.field_42615)
                .add(ModItems.PILLAGERITE_SHOVEL);
        method_10512(class_3489.field_42613)
                .add(ModItems.PILLAGERITE_HOE);
        method_10512(class_3489.field_42614)
                .add(ModItems.PILLAGERITE_PICKAXE);


        method_10512(class_3489.field_48297)
                .add(ModItems.PILLAGERITE_HELMET);
        method_10512(class_3489.field_48296)
                .add(ModItems.PILLAGERITE_CHESTPLATE);
        method_10512(class_3489.field_48295)
                .add(ModItems.PILLAGERITE_LEGGINGS);
        method_10512(class_3489.field_48294)
                .add(ModItems.PILLAGERITE_BOOTS);

        method_10512(class_3489.field_41890)
                .add(ModItems.PILLAGERITE_HELMET, ModItems.PILLAGERITE_CHESTPLATE, ModItems.PILLAGERITE_LEGGINGS, ModItems.PILLAGERITE_BOOTS);
        //*******************************************************************************************************************//

        //************************************* MAGICITE ********************************************************************//
        method_10512(class_3489.field_42611)
                .add(ModItems.MAGICITE_SWORD);
        method_10512(class_3489.field_42612)
                .add(ModItems.MAGICITE_AXE );
        method_10512(class_3489.field_42615)
                .add(ModItems.MAGICITE_SHOVEL);
        method_10512(class_3489.field_42613)
                .add(ModItems.MAGICITE_HOE);
        method_10512(class_3489.field_42614)
                .add(ModItems.MAGICITE_PICKAXE);


        method_10512(class_3489.field_48297)
                .add(ModItems.MAGICITE_HELMET);
        method_10512(class_3489.field_48296)
                .add(ModItems.MAGICITE_CHESTPLATE);
        method_10512(class_3489.field_48295)
                .add(ModItems.MAGICITE_LEGGINGS);
        method_10512(class_3489.field_48294)
                .add(ModItems.MAGICITE_BOOTS);

        method_10512(class_3489.field_41890)
                .add(ModItems.MAGICITE_HELMET, ModItems.MAGICITE_CHESTPLATE, ModItems.MAGICITE_LEGGINGS, ModItems.MAGICITE_BOOTS);
        //*******************************************************************************************************************//
        // BOSS ARMOR
        method_10512(class_3489.field_48297)
                .add(ModItems.BOSS_CROWN);
        method_10512(class_3489.field_48296)
                .add(ModItems.BOSS_CHESTPLATE);
        method_10512(class_3489.field_48295)
                .add(ModItems.BOSS_LEGGINGS);
        method_10512(class_3489.field_48294)
                .add(ModItems.BOSS_BOOTS);
    }
}