package net.scott.minecraftvillagerdimensionmod.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricBlockLootTableProvider;
import net.minecraft.class_44;
import net.minecraft.class_7225;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;

import java.util.concurrent.CompletableFuture;

public class ModLootTableProvider extends FabricBlockLootTableProvider {
    public ModLootTableProvider(FabricDataOutput output, CompletableFuture<class_7225.class_7874> registriesFuture) {
        super(output, registriesFuture);
    }

    @Override
    public void method_10379() {
        //************************************* ROWAN WOOD ****************************************************************//
        method_46025(ModBlocks.ROWAN_LOG);
        method_46025(ModBlocks.ROWAN_WOOD);
        method_46025(ModBlocks.STRIPPED_ROWAN_WOOD);
        method_46025(ModBlocks.STRIPPED_ROWAN_LOG);
        method_46025(ModBlocks.ROWAN_PLANKS);
        method_46025(ModBlocks.ROWAN_SAPLING);

        method_45988(ModBlocks.ROWAN_LEAVES, method_45986(ModBlocks.ROWAN_LEAVES, ModBlocks.ROWAN_SAPLING, 0.05f));
        method_45988(ModBlocks.ROWAN_BERRY_LEAVES, method_45986(ModBlocks.ROWAN_BERRY_LEAVES, ModBlocks.ROWAN_SAPLING, 0.05f));
        method_45988(ModBlocks.ROWAN_BERRY_LEAVES, method_45979(ModItems.ROWAN_BERRIES, new class_44(1)));

        method_46025(ModBlocks.STANDING_ROWAN_SIGN);
        method_46025(ModBlocks.WALL_ROWAN_SIGN);
        method_46025(ModBlocks.WALL_HANGING_ROWAN_SIGN);
        method_46025(ModBlocks.HANGING_ROWAN_SIGN);

        method_46025(ModBlocks.ROWAN_STAIRS);
        method_46025(ModBlocks.ROWAN_BUTTON);
        method_46025(ModBlocks.ROWAN_PRESSURE_PLATE);
        method_46025(ModBlocks.ROWAN_FENCE);
        method_46025(ModBlocks.ROWAN_FENCE_GATE);
        method_46025(ModBlocks.ROWAN_TRAPDOOR);

        method_45988(ModBlocks.ROWAN_DOOR, method_46022(ModBlocks.ROWAN_DOOR));
        method_45988(ModBlocks.ROWAN_SLAB, method_45980(ModBlocks.ROWAN_SLAB));

        //*******************************************************************************************************************//

        //************************************* JUNIPER WOOD ****************************************************************//
        method_46025(ModBlocks.JUNIPER_LOG);
        method_46025(ModBlocks.JUNIPER_WOOD);
        method_46025(ModBlocks.STRIPPED_JUNIPER_WOOD);
        method_46025(ModBlocks.STRIPPED_JUNIPER_LOG);
        method_46025(ModBlocks.JUNIPER_PLANKS);
        method_46025(ModBlocks.JUNIPER_SAPLING);

        // Change Log to sapling
        method_45988(ModBlocks.JUNIPER_LEAVES, method_45986(ModBlocks.JUNIPER_LEAVES, ModBlocks.JUNIPER_SAPLING, 0.05f));
        method_45988(ModBlocks.JUNIPER_BERRY_LEAVES, method_45986(ModBlocks.JUNIPER_BERRY_LEAVES, ModBlocks.JUNIPER_SAPLING, 0.05f));
        method_45988(ModBlocks.JUNIPER_BERRY_LEAVES, method_45979(ModItems.JUNIPER_BERRIES, new class_44(1)));

        method_46025(ModBlocks.STANDING_JUNIPER_SIGN);
        method_46025(ModBlocks.WALL_JUNIPER_SIGN);
        method_46025(ModBlocks.WALL_HANGING_JUNIPER_SIGN);
        method_46025(ModBlocks.HANGING_JUNIPER_SIGN);

        method_46025(ModBlocks.JUNIPER_STAIRS);
        method_46025(ModBlocks.JUNIPER_BUTTON);
        method_46025(ModBlocks.JUNIPER_PRESSURE_PLATE);
        method_46025(ModBlocks.JUNIPER_FENCE);
        method_46025(ModBlocks.JUNIPER_FENCE_GATE);
        method_46025(ModBlocks.JUNIPER_TRAPDOOR);

        method_45988(ModBlocks.JUNIPER_DOOR, method_46022(ModBlocks.JUNIPER_DOOR));
        method_45988(ModBlocks.JUNIPER_SLAB, method_45980(ModBlocks.JUNIPER_SLAB));

        //*******************************************************************************************************************//

        //************************************* SYCAMORE WOOD ****************************************************************//
        method_46025(ModBlocks.SYCAMORE_LOG);
        method_46025(ModBlocks.SYCAMORE_WOOD);
        method_46025(ModBlocks.STRIPPED_SYCAMORE_WOOD);
        method_46025(ModBlocks.STRIPPED_SYCAMORE_LOG);
        method_46025(ModBlocks.SYCAMORE_PLANKS);
        method_46025(ModBlocks.SYCAMORE_SAPLING);

        // Change Log to sapling
        method_45988(ModBlocks.SYCAMORE_LEAVES, method_45986(ModBlocks.SYCAMORE_LEAVES, ModBlocks.SYCAMORE_SAPLING, 0.005f));

        method_46025(ModBlocks.STANDING_SYCAMORE_SIGN);
        method_46025(ModBlocks.WALL_SYCAMORE_SIGN);
        method_46025(ModBlocks.WALL_HANGING_SYCAMORE_SIGN);
        method_46025(ModBlocks.HANGING_SYCAMORE_SIGN);

        method_46025(ModBlocks.SYCAMORE_STAIRS);
        method_46025(ModBlocks.SYCAMORE_BUTTON);
        method_46025(ModBlocks.SYCAMORE_PRESSURE_PLATE);
        method_46025(ModBlocks.SYCAMORE_FENCE);
        method_46025(ModBlocks.SYCAMORE_FENCE_GATE);
        method_46025(ModBlocks.SYCAMORE_TRAPDOOR);

        method_45988(ModBlocks.SYCAMORE_DOOR, method_46022(ModBlocks.SYCAMORE_DOOR));
        method_45988(ModBlocks.SYCAMORE_SLAB, method_45980(ModBlocks.SYCAMORE_SLAB));
        //*******************************************************************************************************************//
    }
}