package net.scott.minecraftvillagerdimensionmod.entity.custom;

import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1309;
import net.minecraft.class_1680;
import net.minecraft.class_1937;
import net.minecraft.class_3966;
import net.minecraft.class_6880;
import net.minecraft.class_7924;
import net.minecraft.class_8110;
import net.minecraft.class_8111;

public class DamagingSnowballEntity extends class_1680 {
    // This multiplier will make the snowball deal more damage than a normal one.
    private static final float DAMAGE_MULTIPLIER = 5.0f;

    public DamagingSnowballEntity(class_1299<? extends class_1680> entityType, class_1937 world) {
        super(entityType, world);
    }

    public DamagingSnowballEntity(class_1937 world, class_1309 owner) {
        // Note: Using the default SNOWBALL EntityType.
        super(class_1299.field_6068, world);
    }

    @Override
    protected void method_7454(class_3966 hitResult) {
        super.method_7454(hitResult);
        // Only run on the server side.
        if (!this.method_37908().field_9236) {
            if (hitResult.method_17782() instanceof class_1309) {
                class_6880<class_8110> thrownDamageType = this.method_37908()
                        .method_30349()
                        .method_30530(class_7924.field_42534)
                        .method_40264(class_8111.field_42328)
                        .orElseThrow(() -> new IllegalStateException("Thrown damage type missing"));
                // Create an indirect damage source with a damage type string ("thrown") that suits your needs.
                class_1282 damageSource = new class_1282(thrownDamageType, this, this.method_24921());
                hitResult.method_17782().method_5643(damageSource, DAMAGE_MULTIPLIER);
            }
            this.method_31472();
        }
    }
}
