package net.scott.minecraftvillagerdimensionmod.item.custom;

import com.google.common.base.Suppliers;
import net.minecraft.class_1832;
import net.minecraft.class_1856;
import net.minecraft.class_2248;
import net.minecraft.class_6862;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;
import net.scott.minecraftvillagerdimensionmod.util.ModTags;

import java.util.function.Supplier;

public class PillageriteToolMaterial {
    public enum pillageriteToolMaterial implements class_1832{
        PILLAGERITE_INGOT(
                2750,
                12.0F,
                7.2F,
                16,
                ModTags.Blocks.INCORRECT_FOR_PILLAGERITE_TOOL,
                () -> class_1856.method_8091(ModItems.PILLAGERITE_INGOT));

        private final class_6862<class_2248> inverseTag;
        private final int itemDurability;
        private final float miningSpeed;
        private final float attackDamage;
        private final int enchantability;
        private final Supplier<class_1856> repairIngredient;

        pillageriteToolMaterial(int itemDurability, float miningSpeed, float attackDamage, int enchantability, class_6862<class_2248> inverseTag, Supplier<class_1856> repairIngredient){
            this.itemDurability = itemDurability;
            this.miningSpeed = miningSpeed;
            this.attackDamage = attackDamage;
            this.enchantability = enchantability;
            this.inverseTag = inverseTag;
            this.repairIngredient = Suppliers.memoize(repairIngredient::get);
        }

        @Override
        public int method_8025(){
            return this.itemDurability;
        }

        @Override
        public float method_8027(){
            return this.miningSpeed;
        }

        @Override
        public float method_8028() {
            return this.attackDamage;
        }

        @Override
        public class_6862<class_2248> method_58419(){
            return this.inverseTag;
        }

        @Override
        public int method_8026(){
            return this.enchantability;
        }

        @Override
        public class_1856 method_8023(){
            return this.repairIngredient.get();
        }
    }
}
