package net.scott.minecraftvillagerdimensionmod.datagen;


import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricRecipeProvider;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricTagProvider;
import net.minecraft.class_1856;
import net.minecraft.class_2066;
import net.minecraft.class_2447;
import net.minecraft.class_7225;
import net.minecraft.class_7800;
import net.minecraft.class_8790;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;
import net.scott.minecraftvillagerdimensionmod.item.custom.ModArmorMaterials;

import java.util.concurrent.CompletableFuture;

public class ModRecipeProvider extends FabricRecipeProvider {

    public ModRecipeProvider(FabricDataOutput output, CompletableFuture<class_7225.class_7874> registriesFuture) {
        super(output, registriesFuture);

    }
    @Override
    public void method_10419(class_8790 exporter) {

        //************************************* ROWAN WOOD ****************************************************************//
        method_32814(exporter, class_7800.field_40634, ModBlocks.ROWAN_SLAB, ModBlocks.ROWAN_PLANKS);
        method_32808(ModBlocks.ROWAN_STAIRS, class_1856.method_8091(ModBlocks.ROWAN_PLANKS))
                .method_33530("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG)
                        ).method_10431(exporter);
        method_33548(ModBlocks.ROWAN_FENCE_GATE, class_1856.method_8091(ModBlocks.ROWAN_PLANKS))
                .method_33530("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG)
                ).method_10431(exporter);
        method_33546(ModBlocks.ROWAN_FENCE, class_1856.method_8091(ModBlocks.ROWAN_PLANKS))
                .method_33530("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG)
                ).method_10431(exporter);
        method_32813(exporter, ModBlocks.ROWAN_PRESSURE_PLATE, ModBlocks.ROWAN_PLANKS);

        method_33544(ModBlocks.ROWAN_DOOR, class_1856.method_8091(ModBlocks.ROWAN_PLANKS))
                .method_33530("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG)
                ).method_10431(exporter);
        method_33553(ModBlocks.ROWAN_TRAPDOOR, class_1856.method_8091(ModBlocks.ROWAN_PLANKS))
                .method_33530("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG)
                ).method_10431(exporter);
        method_46208(exporter, ModItems.HANGING_ROWAN_SIGN, ModBlocks.ROWAN_PLANKS);
        method_33555(ModItems.ROWAN_SIGN, class_1856.method_8091(ModBlocks.ROWAN_PLANKS))
                .method_33530("a_dark_wood", class_2066.class_2068.method_8959(ModBlocks.ROWAN_LOG)
                ).method_10431(exporter);

        method_24478(exporter, ModItems.ROWAN_BOAT, ModBlocks.ROWAN_PLANKS);
        method_42754(exporter, ModItems.ROWAN_CHEST_BOAT, ModItems.JUNIPER_BOAT);
        //*******************************************************************************************************************//

        //************************************* JUNIPER WOOD ****************************************************************//
        method_32814(exporter, class_7800.field_40634, ModBlocks.JUNIPER_SLAB, ModBlocks.JUNIPER_PLANKS);
        method_32808(ModBlocks.JUNIPER_STAIRS, class_1856.method_8091(ModBlocks.JUNIPER_PLANKS))
                .method_33530("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG)
                ).method_10431(exporter);
        method_33548(ModBlocks.JUNIPER_FENCE_GATE, class_1856.method_8091(ModBlocks.JUNIPER_PLANKS))
                .method_33530("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG)
                ).method_10431(exporter);
        method_33546(ModBlocks.JUNIPER_FENCE, class_1856.method_8091(ModBlocks.JUNIPER_PLANKS))
                .method_33530("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG)
                ).method_10431(exporter);
        method_32813(exporter, ModBlocks.JUNIPER_PRESSURE_PLATE, ModBlocks.JUNIPER_PLANKS);

        method_33544(ModBlocks.JUNIPER_DOOR, class_1856.method_8091(ModBlocks.JUNIPER_PLANKS))
                .method_33530("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG)
                ).method_10431(exporter);
        method_33553(ModBlocks.JUNIPER_TRAPDOOR, class_1856.method_8091(ModBlocks.JUNIPER_PLANKS))
                .method_33530("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG)
                ).method_10431(exporter);
        method_46208(exporter, ModItems.HANGING_JUNIPER_SIGN, ModBlocks.JUNIPER_PLANKS);
        method_33555(ModItems.JUNIPER_SIGN, class_1856.method_8091(ModBlocks.JUNIPER_PLANKS))
                .method_33530("feeling_grey", class_2066.class_2068.method_8959(ModBlocks.JUNIPER_LOG)
                ).method_10431(exporter);
        method_24478(exporter, ModItems.JUNIPER_BOAT, ModBlocks.JUNIPER_PLANKS);
        method_42754(exporter, ModItems.JUNIPER_CHEST_BOAT, ModItems.JUNIPER_BOAT);
        //*******************************************************************************************************************//

        //************************************* SYCAMORE WOOD ****************************************************************//
        method_32814(exporter, class_7800.field_40634, ModBlocks.SYCAMORE_SLAB, ModBlocks.SYCAMORE_PLANKS);
        method_32808(ModBlocks.SYCAMORE_STAIRS, class_1856.method_8091(ModBlocks.SYCAMORE_PLANKS))
                .method_33530("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG)
                ).method_10431(exporter);
        method_33548(ModBlocks.SYCAMORE_FENCE_GATE, class_1856.method_8091(ModBlocks.SYCAMORE_PLANKS))
                .method_33530("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG)
                ).method_10431(exporter);
        method_33546(ModBlocks.SYCAMORE_FENCE, class_1856.method_8091(ModBlocks.SYCAMORE_PLANKS))
                .method_33530("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG)
                ).method_10431(exporter);
        method_32813(exporter, ModBlocks.SYCAMORE_PRESSURE_PLATE, ModBlocks.SYCAMORE_PLANKS);

        method_33544(ModBlocks.SYCAMORE_DOOR, class_1856.method_8091(ModBlocks.SYCAMORE_PLANKS))
                .method_33530("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG)
                ).method_10431(exporter);
        method_33553(ModBlocks.SYCAMORE_TRAPDOOR, class_1856.method_8091(ModBlocks.SYCAMORE_PLANKS))
                .method_33530("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG)
                ).method_10431(exporter);
        method_46208(exporter, ModItems.HANGING_SYCAMORE_SIGN, ModBlocks.SYCAMORE_PLANKS);
        method_33555(ModItems.SYCAMORE_SIGN, class_1856.method_8091(ModBlocks.SYCAMORE_PLANKS))
                .method_33530("youre_syc", class_2066.class_2068.method_8959(ModBlocks.SYCAMORE_LOG)
                ).method_10431(exporter);
        method_24478(exporter, ModItems.SYCAMORE_BOAT, ModBlocks.SYCAMORE_PLANKS);
        method_42754(exporter, ModItems.SYCAMORE_CHEST_BOAT, ModItems.SYCAMORE_BOAT);
        //*******************************************************************************************************************//
        
        // ANCIENT GEMSTONE
        class_2447.method_10437(class_7800.field_40639, ModItems.ANCIENT_GEMSTONE_HELMET)
                .method_10434('E', ModItems.ANCIENT_GEMSTONE_DUST)
                .method_10439("EEE")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.ANCIENT_GEMSTONE_DUST), method_10426(ModItems.ANCIENT_GEMSTONE_DUST))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.ANCIENT_GEMSTONE_CHESTPLATE)
                .method_10434('E', ModItems.ANCIENT_GEMSTONE_DUST)
                .method_10439("E E")
                .method_10439("EEE")
                .method_10439("EEE")
                .method_10429(method_32807(ModItems.ANCIENT_GEMSTONE_DUST), method_10426(ModItems.ANCIENT_GEMSTONE_DUST))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.ANCIENT_GEMSTONE_LEGGINGS)
                .method_10434('E', ModItems.ANCIENT_GEMSTONE_DUST)
                .method_10439("EEE")
                .method_10439("E E")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.ANCIENT_GEMSTONE_DUST), method_10426(ModItems.ANCIENT_GEMSTONE_DUST))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.ANCIENT_GEMSTONE_BOOTS)
                .method_10434('E', ModItems.ANCIENT_GEMSTONE_DUST)
                .method_10439("E E")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.ANCIENT_GEMSTONE_DUST), method_10426(ModItems.ANCIENT_GEMSTONE_DUST))
                .method_10431(exporter);

        // PILLAGERITE
        class_2447.method_10437(class_7800.field_40639, ModItems.PILLAGERITE_HELMET)
                .method_10434('E', ModItems.PILLAGERITE_INGOT)
                .method_10439("EEE")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.PILLAGERITE_INGOT), method_10426(ModItems.PILLAGERITE_INGOT))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.PILLAGERITE_CHESTPLATE)
                .method_10434('E', ModItems.PILLAGERITE_INGOT)
                .method_10439("E E")
                .method_10439("EEE")
                .method_10439("EEE")
                .method_10429(method_32807(ModItems.PILLAGERITE_INGOT), method_10426(ModItems.PILLAGERITE_INGOT))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.PILLAGERITE_LEGGINGS)
                .method_10434('E', ModItems.PILLAGERITE_INGOT)
                .method_10439("EEE")
                .method_10439("E E")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.PILLAGERITE_INGOT), method_10426(ModItems.PILLAGERITE_INGOT))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.PILLAGERITE_BOOTS)
                .method_10434('E', ModItems.PILLAGERITE_INGOT)
                .method_10439("E E")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.PILLAGERITE_INGOT), method_10426(ModItems.PILLAGERITE_INGOT))
                .method_10431(exporter);

        // MAGICITE
        class_2447.method_10437(class_7800.field_40639, ModItems.MAGICITE_HELMET)
                .method_10434('E', ModItems.MAGICITE_DUST)
                .method_10439("EEE")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.MAGICITE_DUST), method_10426(ModItems.MAGICITE_DUST))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.MAGICITE_CHESTPLATE)
                .method_10434('E', ModItems.MAGICITE_DUST)
                .method_10439("E E")
                .method_10439("EEE")
                .method_10439("EEE")
                .method_10429(method_32807(ModItems.MAGICITE_DUST), method_10426(ModItems.MAGICITE_DUST))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.MAGICITE_LEGGINGS)
                .method_10434('E', ModItems.MAGICITE_DUST)
                .method_10439("EEE")
                .method_10439("E E")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.MAGICITE_DUST), method_10426(ModItems.MAGICITE_DUST))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40639, ModItems.MAGICITE_BOOTS)
                .method_10434('E', ModItems.MAGICITE_DUST)
                .method_10439("E E")
                .method_10439("E E")
                .method_10429(method_32807(ModItems.MAGICITE_DUST), method_10426(ModItems.MAGICITE_DUST))
                .method_10431(exporter);

        class_2447.method_10437(class_7800.field_40640, ModItems.JUNIPER_FLOUR)
                .method_10434('E', ModItems.JUNIPER_BERRIES)
                .method_10439("   ")
                .method_10439("EEE")
                .method_10429(method_32807(ModItems.JUNIPER_BERRIES), method_10426(ModItems.JUNIPER_FLOUR))
                .method_10431(exporter);
        class_2447.method_10437(class_7800.field_40640, ModItems.JUNIPER_BREAD)
                .method_10434('E', ModItems.JUNIPER_FLOUR)
                .method_10439("   ")
                .method_10439("EEE")
                .method_10429(method_32807(ModItems.JUNIPER_FLOUR), method_10426(ModItems.JUNIPER_BREAD))
                .method_10431(exporter);
    }
}

