package net.scott.minecraftvillagerdimensionmod.entity;

import com.terraformersmc.terraform.boat.api.TerraformBoatType;
import com.terraformersmc.terraform.boat.api.TerraformBoatTypeRegistry;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_5321;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;

public class ModBoats {
    public static final class_2960 ROWAN_BOAT_ID = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "rowan_boat");
    public static final class_2960 ROWAN_CHEST_BOAT_ID = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "rowan_chest_boat");

    public static final class_5321<TerraformBoatType> ROWAN_BOAT_KEY = TerraformBoatTypeRegistry.createKey(ROWAN_BOAT_ID);


    public static final class_2960 JUNIPER_BOAT_ID = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "juniper_boat");
    public static final class_2960 JUNIPER_CHEST_BOAT_ID = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "juniper_chest_boat");

    public static final class_5321<TerraformBoatType> JUNIPER_BOAT_KEY = TerraformBoatTypeRegistry.createKey(JUNIPER_BOAT_ID);


    public static final class_2960 SYCAMORE_BOAT_ID = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "sycamore_boat");
    public static final class_2960 SYCAMORE_CHEST_BOAT_ID = class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "sycamore_chest_boat");

    public static final class_5321<TerraformBoatType> SYCAMORE_BOAT_KEY = TerraformBoatTypeRegistry.createKey(SYCAMORE_BOAT_ID);


    public static void registerBoats(){
        TerraformBoatType rowanBoat = new TerraformBoatType.Builder()
                .item(ModItems.ROWAN_BOAT)
                .chestItem(ModItems.ROWAN_CHEST_BOAT)
                .planks(ModBlocks.ROWAN_PLANKS.method_8389())
                .build();

        TerraformBoatType juniperBoat = new TerraformBoatType.Builder()
                .item(ModItems.JUNIPER_BOAT)
                .chestItem(ModItems.JUNIPER_CHEST_BOAT)
                .planks(ModBlocks.JUNIPER_PLANKS.method_8389())
                .build();

        TerraformBoatType sycamoreBoat = new TerraformBoatType.Builder()
                .item(ModItems.SYCAMORE_BOAT)
                .chestItem(ModItems.SYCAMORE_CHEST_BOAT)
                .planks(ModBlocks.SYCAMORE_PLANKS.method_8389())
                .build();


        class_2378.method_39197(TerraformBoatTypeRegistry.INSTANCE, ROWAN_BOAT_KEY, rowanBoat);
        class_2378.method_39197(TerraformBoatTypeRegistry.INSTANCE, JUNIPER_BOAT_KEY, juniperBoat);
        class_2378.method_39197(TerraformBoatTypeRegistry.INSTANCE, SYCAMORE_BOAT_KEY, sycamoreBoat);

    }
}
