package net.scott.minecraftvillagerdimensionmod.entity.custom;

import net.minecraft.class_1282;
import net.minecraft.class_1299;
import net.minecraft.class_1301;
import net.minecraft.class_1338;
import net.minecraft.class_1374;
import net.minecraft.class_1378;
import net.minecraft.class_1422;
import net.minecraft.class_1657;
import net.minecraft.class_1799;
import net.minecraft.class_1937;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_4050;
import net.minecraft.class_5132;
import net.minecraft.class_5134;
import net.minecraft.class_7094;
import net.scott.minecraftvillagerdimensionmod.item.ModItems;

public class OrangeKoiFishEntity extends class_1422 {

    public final class_7094 idleAnimationState = new class_7094();
    private int idleAnimationTimeout = 0;

    public OrangeKoiFishEntity(class_1299<? extends class_1422> entityType, class_1937 world) {
        super(entityType, world);
    }

    @Override
    public void method_5773(){
        super.method_5773();
        if(this.method_37908().method_8608()){
            setupAnimationStates();
        }
    }

    private void setupAnimationStates() {
        if (this.idleAnimationTimeout <= 0){
            this.idleAnimationTimeout = this.field_5974.method_43048(10) + 20;
            this.idleAnimationState.method_41322(this.field_6012);
        }else{
            --this.idleAnimationTimeout;
        }
    }

    @Override
    protected void method_48565(float posDelta){
        float f = this.method_18376() == class_4050.field_18079 ? Math.min(posDelta * 6.0f, 1.0f) : 0.0f;
        this.field_42108.method_48568(f, 1f);
    }


    public static class_5132.class_5133 createOrangeKoiFishAttributes(){
        return class_1422.method_26879()
                .method_26868(class_5134.field_23716, 5)
                .method_26868(class_5134.field_23719, 0.2f);
    }

    @Override
    protected void method_5959() {
        this.field_6201.method_6277(0, new class_1374(this, 1.25));
        this.field_6201.method_6277(2, new class_1338<>(this, class_1657.class, 8.0F, 1.6, 1.4, class_1301.field_6155::test));
        this.field_6201.method_6277(4, new class_1378(this, 5, 5));
    }

    // Add Salmon sound effects
    @Override
    protected class_3414 method_6457() {
        return class_3417.field_14563;
    }

    @Override
    protected class_3414 method_5994() {
        return class_3417.field_15033;
    }

    @Override
    protected class_3414 method_6011(class_1282 source) {
        return class_3417.field_14638;
    }

    @Override
    protected class_3414 method_6002() {
        return class_3417.field_15123;
    }

    @Override
    public class_1799 method_6452() {
        return new class_1799(ModItems.ORANGE_KOI_BUCKET);
    }
}
