package net.scott.minecraftvillagerdimensionmod.item;

import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroup;
import net.minecraft.class_1761;
import net.minecraft.class_1799;
import net.minecraft.class_2378;
import net.minecraft.class_2561;
import net.minecraft.class_2960;
import net.minecraft.class_7923;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.entity.ModBoats;

public class ModItemGroups {

    public static final class_1761 MINECRAFT_VILLAGER_DIMENSION_MOD_GROUP = class_2378.method_10230(class_7923.field_44687,
            class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "ancient_gemstone"),
            FabricItemGroup.builder().method_47321(class_2561.method_43471("itemgroup.ancient_gemstone"))
                    .method_47320(() -> new class_1799(ModItems.ANCIENT_GEMSTONE)).method_47317(((displayContext, entries) -> {
                        // ANCIENT GEMSTONE
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_DUST);

                        entries.method_45421(ModBlocks.ANCIENT_GEMSTONE_ORE);
                        entries.method_45421(ModBlocks.DEEPSLATE_ANCIENT_GEMSTONE_ORE);
                        entries.method_45421(ModBlocks.ANCIENT_GEMSTONE_BLOCK);

                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_HELMET);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_CHESTPLATE);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_LEGGINGS);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_BOOTS);

                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_PICKAXE);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_AXE);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_SWORD);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_HOE);
                        entries.method_45421(ModItems.ANCIENT_GEMSTONE_SHOVEL);

                        // MAGICITE
                        entries.method_45421(ModItems.MAGICITE);
                        entries.method_45421(ModItems.MAGICITE_DUST);

                        entries.method_45421(ModBlocks.MAGICITE_ORE);
                        entries.method_45421(ModBlocks.DEEPSLATE_MAGICITE_ORE);
                        entries.method_45421(ModBlocks.MAGICITE_BLOCK);

                        entries.method_45421(ModItems.MAGICITE_HELMET);
                        entries.method_45421(ModItems.MAGICITE_CHESTPLATE);
                        entries.method_45421(ModItems.MAGICITE_LEGGINGS);
                        entries.method_45421(ModItems.MAGICITE_BOOTS);

                        entries.method_45421(ModItems.MAGICITE_PICKAXE);
                        entries.method_45421(ModItems.MAGICITE_AXE);
                        entries.method_45421(ModItems.MAGICITE_SWORD);
                        entries.method_45421(ModItems.MAGICITE_HOE);
                        entries.method_45421(ModItems.MAGICITE_SHOVEL);

                        // PILLAGERITE
                        entries.method_45421(ModItems.PILLAGERITE);
                        entries.method_45421(ModItems.PILLAGERITE_INGOT);

                        entries.method_45421(ModBlocks.PILLAGERITE_ORE);
                        entries.method_45421(ModBlocks.DEEPSLATE_PILLAGERITE_ORE);
                        entries.method_45421(ModBlocks.PILLAGERITE_BLOCK);

                        entries.method_45421(ModItems.PILLAGERITE_HELMET);
                        entries.method_45421(ModItems.PILLAGERITE_CHESTPLATE);
                        entries.method_45421(ModItems.PILLAGERITE_LEGGINGS);
                        entries.method_45421(ModItems.PILLAGERITE_BOOTS);

                        entries.method_45421(ModItems.PILLAGERITE_PICKAXE);
                        entries.method_45421(ModItems.PILLAGERITE_AXE);
                        entries.method_45421(ModItems.PILLAGERITE_SWORD);
                        entries.method_45421(ModItems.PILLAGERITE_HOE);
                        entries.method_45421(ModItems.PILLAGERITE_SHOVEL);

                        // BOSS ARMOR
                        entries.method_45421(ModItems.BOSS_CROWN);
                        entries.method_45421(ModItems.BOSS_CHESTPLATE);
                        entries.method_45421(ModItems.BOSS_LEGGINGS);
                        entries.method_45421(ModItems.BOSS_BOOTS);

                        // MISC ITEMS
                        entries.method_45421(ModItems.EMERALD_TORCH_ITEM);

                        // ROWAN WOOD
                        entries.method_45421(ModBlocks.ROWAN_LOG);
                        entries.method_45421(ModBlocks.ROWAN_WOOD);
                        entries.method_45421(ModBlocks.STRIPPED_ROWAN_LOG);
                        entries.method_45421(ModBlocks.STRIPPED_ROWAN_WOOD);
                        entries.method_45421(ModBlocks.ROWAN_PLANKS);
                        entries.method_45421(ModBlocks.ROWAN_LEAVES);
                        entries.method_45421(ModBlocks.ROWAN_BERRY_LEAVES);

                        entries.method_45421(ModItems.ROWAN_SIGN);
                        entries.method_45421(ModItems.HANGING_ROWAN_SIGN);

                        entries.method_45421(ModBlocks.ROWAN_SLAB);
                        entries.method_45421(ModBlocks.ROWAN_STAIRS);
                        entries.method_45421(ModBlocks.ROWAN_PRESSURE_PLATE);
                        entries.method_45421(ModBlocks.ROWAN_BUTTON);
                        entries.method_45421(ModBlocks.ROWAN_DOOR);
                        entries.method_45421(ModBlocks.ROWAN_TRAPDOOR);
                        entries.method_45421(ModBlocks.ROWAN_FENCE);
                        entries.method_45421(ModBlocks.ROWAN_FENCE_GATE);

                        entries.method_45421(ModItems.ROWAN_BOAT);
                        entries.method_45421(ModItems.ROWAN_CHEST_BOAT);

                        entries.method_45421(ModBlocks.ROWAN_SAPLING);
                        entries.method_45421(ModItems.ROWAN_BERRIES);

                        // JUNIPER WOOD
                        entries.method_45421(ModBlocks.JUNIPER_LOG);
                        entries.method_45421(ModBlocks.JUNIPER_WOOD);
                        entries.method_45421(ModBlocks.STRIPPED_JUNIPER_LOG);
                        entries.method_45421(ModBlocks.STRIPPED_JUNIPER_WOOD);
                        entries.method_45421(ModBlocks.JUNIPER_PLANKS);
                        entries.method_45421(ModBlocks.JUNIPER_LEAVES);
                        entries.method_45421(ModBlocks.JUNIPER_BERRY_LEAVES);

                        entries.method_45421(ModItems.JUNIPER_SIGN);
                        entries.method_45421(ModItems.HANGING_JUNIPER_SIGN);

                        entries.method_45421(ModBlocks.JUNIPER_SLAB);
                        entries.method_45421(ModBlocks.JUNIPER_STAIRS);
                        entries.method_45421(ModBlocks.JUNIPER_PRESSURE_PLATE);
                        entries.method_45421(ModBlocks.JUNIPER_BUTTON);
                        entries.method_45421(ModBlocks.JUNIPER_DOOR);
                        entries.method_45421(ModBlocks.JUNIPER_TRAPDOOR);
                        entries.method_45421(ModBlocks.JUNIPER_FENCE);
                        entries.method_45421(ModBlocks.JUNIPER_FENCE_GATE);

                        entries.method_45421(ModItems.JUNIPER_BOAT);
                        entries.method_45421(ModItems.JUNIPER_CHEST_BOAT);

                        entries.method_45421(ModBlocks.JUNIPER_SAPLING);
                        entries.method_45421(ModItems.JUNIPER_BERRIES);
                        entries.method_45421(ModItems.JUNIPER_BREAD);
                        entries.method_45421(ModItems.JUNIPER_FLOUR);

                        // SYCAMORE WOOD
                        entries.method_45421(ModBlocks.SYCAMORE_LOG);
                        entries.method_45421(ModBlocks.SYCAMORE_WOOD);
                        entries.method_45421(ModBlocks.STRIPPED_SYCAMORE_LOG);
                        entries.method_45421(ModBlocks.STRIPPED_SYCAMORE_WOOD);
                        entries.method_45421(ModBlocks.SYCAMORE_PLANKS);
                        entries.method_45421(ModBlocks.SYCAMORE_LEAVES);

                        entries.method_45421(ModItems.SYCAMORE_SIGN);
                        entries.method_45421(ModItems.HANGING_SYCAMORE_SIGN);

                        entries.method_45421(ModBlocks.SYCAMORE_SLAB);
                        entries.method_45421(ModBlocks.SYCAMORE_STAIRS);
                        entries.method_45421(ModBlocks.SYCAMORE_PRESSURE_PLATE);
                        entries.method_45421(ModBlocks.SYCAMORE_BUTTON);
                        entries.method_45421(ModBlocks.SYCAMORE_DOOR);
                        entries.method_45421(ModBlocks.SYCAMORE_TRAPDOOR);
                        entries.method_45421(ModBlocks.SYCAMORE_FENCE);
                        entries.method_45421(ModBlocks.SYCAMORE_FENCE_GATE);

                        entries.method_45421(ModItems.SYCAMORE_BOAT);
                        entries.method_45421(ModItems.SYCAMORE_CHEST_BOAT);

                        entries.method_45421(ModBlocks.SYCAMORE_SAPLING);

                        entries.method_45421(ModItems.ORANGE_KOI_FISH_SPAWN_EGG);
                        entries.method_45421(ModItems.WHITE_KOI_FISH_SPAWN_EGG);
                        entries.method_45421(ModItems.BLACK_KOI_FISH_SPAWN_EGG);
                        entries.method_45421(ModItems.PILLAGER_BRUTE_BOSS_SPAWN_EGG);
                        entries.method_45421(ModItems.MONARCH_BUTTERFLY_SPAWN_EGG);
                        entries.method_45421(ModItems.EVIL_VILLAGER_BOSS_SPAWN_EGG);
                        entries.method_45421(ModItems.PILLAGER_WIZARD_BOSS_SPAWN_EGG);

                        entries.method_45421(ModItems.BLACK_KOI_BUCKET);
                        entries.method_45421(ModItems.ORANGE_KOI_BUCKET);
                        entries.method_45421(ModItems.WHITE_KOI_BUCKET);



                    })).method_47324());

    public static void registerItemGroups(){
        MinecraftVillagerDimensionMod.LOGGER.info("Registering Item Groups for " + MinecraftVillagerDimensionMod.MOD_ID);
    }
}
