package net.scott.minecraftvillagerdimensionmod.item;
import com.terraformersmc.terraform.boat.api.item.TerraformBoatItemHelper;
import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroupEntries;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.class_1738;
import net.minecraft.class_1743;
import net.minecraft.class_1785;
import net.minecraft.class_1792;
import net.minecraft.class_1794;
import net.minecraft.class_1810;
import net.minecraft.class_1821;
import net.minecraft.class_1822;
import net.minecraft.class_1826;
import net.minecraft.class_1827;
import net.minecraft.class_1829;
import net.minecraft.class_2350;
import net.minecraft.class_2378;
import net.minecraft.class_2960;
import net.minecraft.class_3417;
import net.minecraft.class_3612;
import net.minecraft.class_7706;
import net.minecraft.class_7923;
import net.minecraft.item.*;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.block.ModBlocks;
import net.scott.minecraftvillagerdimensionmod.entity.ModBoats;
import net.scott.minecraftvillagerdimensionmod.entity.ModEntities;
import net.scott.minecraftvillagerdimensionmod.item.custom.*;

public class ModItems {

    // This is where I add items

    public static final class_1792 EMERALD_TORCH_ITEM = registerItem("emerald_torch_item",
            new class_1827(ModBlocks.EMERALD_TORCH, ModBlocks.WALL_EMERALD_TORCH, new class_1792.class_1793(), class_2350.field_11033));

    public static final class_1792 ANCIENT_GEMSTONE_PICKAXE = registerItem("ancient_gemstone_pickaxe", new class_1810(AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, 1, -2.7F
    ))));
    public static final class_1792 ANCIENT_GEMSTONE_AXE = registerItem("ancient_gemstone_axe", new class_1743(AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, 5, -2.8F
    ))));
    public static final class_1792 ANCIENT_GEMSTONE_SWORD= registerItem("ancient_gemstone_sword", new class_1829(AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, 3, -2.4F
    ))));
    public static final class_1792 ANCIENT_GEMSTONE_SHOVEL = registerItem("ancient_gemstone_shovel", new class_1821(AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, 1.5F, -2.8F
    ))));
    public static final class_1792 ANCIENT_GEMSTONE_HOE = registerItem("ancient_gemstone_hoe", new class_1794(AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            AncientGemstoneToolMaterial.ancientGemstoneToolMaterial.ANCIENT_GEMSTONE_DUST, -6, 1
    ))));



    public static final class_1792  ANCIENT_GEMSTONE_HELMET = registerItem("ancient_gemstone_helmet",
            new CustomArmorItem(ModArmorMaterials.ANCIENT_GEMSTONE_DUST,
                    class_1738.class_8051.field_41934,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41934.method_56690(38))));

    public static final class_1792  ANCIENT_GEMSTONE_BOOTS = registerItem("ancient_gemstone_boots",
            new class_1738(ModArmorMaterials.ANCIENT_GEMSTONE_DUST,
                    class_1738.class_8051.field_41937,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41937.method_56690(38))));

    public static final class_1792  ANCIENT_GEMSTONE_CHESTPLATE = registerItem("ancient_gemstone_chestplate",
            new class_1738(ModArmorMaterials.ANCIENT_GEMSTONE_DUST,
                    class_1738.class_8051.field_41935,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41935.method_56690(38))));

    public static final class_1792  ANCIENT_GEMSTONE_LEGGINGS = registerItem("ancient_gemstone_leggings",
            new class_1738(ModArmorMaterials.ANCIENT_GEMSTONE_DUST,
                    class_1738.class_8051.field_41936,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41936.method_56690(38))));





    public static final class_1792 PILLAGERITE_PICKAXE = registerItem("pillagerite_pickaxe", new class_1810(PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, new class_1792.class_1793().method_57348(class_1810.method_57346(
            PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, 1, -2.7F
    ))));
    public static final class_1792 PILLAGERITE_AXE = registerItem("pillagerite_axe", new class_1743(PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, new class_1792.class_1793().method_57348(class_1810.method_57346(
            PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, 5, -2.8F
    ))));
    public static final class_1792 PILLAGERITE_SWORD = registerItem("pillagerite_sword", new class_1829(PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, new class_1792.class_1793().method_57348(class_1810.method_57346(
            PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, 3, -2.4F
    ))));
    public static final class_1792 PILLAGERITE_SHOVEL = registerItem("pillagerite_shovel", new class_1821(PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, new class_1792.class_1793().method_57348(class_1810.method_57346(
            PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, 1.3F, -2.8F
    ))));
    public static final class_1792 PILLAGERITE_HOE = registerItem("pillagerite_hoe", new class_1794(PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, new class_1792.class_1793().method_57348(class_1810.method_57346(
            PillageriteToolMaterial.pillageriteToolMaterial.PILLAGERITE_INGOT, -7.2F, 1
    ))));

    public static final class_1792 PILLAGERITE_HELMET = registerItem("pillagerite_helmet",
            new class_1738(ModArmorMaterials.PILLAGERITE_INGOT,
                    class_1738.class_8051.field_41934,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41934.method_56690(45))));

    public static final class_1792 PILLAGERITE_BOOTS = registerItem("pillagerite_boots",
            new class_1738(ModArmorMaterials.PILLAGERITE_INGOT,
                    class_1738.class_8051.field_41937,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41937.method_56690(45))));

    public static final class_1792 PILLAGERITE_CHESTPLATE = registerItem("pillagerite_chestplate",
            new class_1738(ModArmorMaterials.PILLAGERITE_INGOT,
                    class_1738.class_8051.field_41935,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41935.method_56690(45))));

    public static final class_1792 PILLAGERITE_LEGGINGS = registerItem("pillagerite_leggings",
            new class_1738(ModArmorMaterials.PILLAGERITE_INGOT,
                    class_1738.class_8051.field_41936,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41936.method_56690(45))));



    // MAGICITE TOOLS AND ARMOR
    public static final class_1792 MAGICITE_PICKAXE = registerItem("magicite_pickaxe", new class_1810(MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, 1, -2.7F
    ))));
    public static final class_1792 MAGICITE_AXE = registerItem("magicite_axe", new class_1743(MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, 5, -2.8F
    ))));
    public static final class_1792 MAGICITE_SWORD= registerItem("magicite_sword", new class_1829(MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, 3, -2.4F
    ))));
    public static final class_1792 MAGICITE_SHOVEL = registerItem("magicite_shovel", new class_1821(MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, 1.5F, -2.8F
    ))));
    public static final class_1792 MAGICITE_HOE = registerItem("magicite_hoe", new class_1794(MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, new class_1792.class_1793().method_57348(class_1810.method_57346(
            MagiciteToolMaterial.magiciteToolMaterial.MAGICITE_DUST, -5, 1
    ))));

    public static final class_1792 MAGICITE_HELMET = registerItem("magicite_helmet",
            new class_1738(ModArmorMaterials.MAGICITE_DUST,
                    class_1738.class_8051.field_41934,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41934.method_56690(40))));

    public static final class_1792 MAGICITE_BOOTS = registerItem("magicite_boots",
            new class_1738(ModArmorMaterials.MAGICITE_DUST,
                    class_1738.class_8051.field_41937,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41937.method_56690(40))));

    public static final class_1792 MAGICITE_CHESTPLATE = registerItem("magicite_chestplate",
            new class_1738(ModArmorMaterials.MAGICITE_DUST,
                    class_1738.class_8051.field_41935,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41935.method_56690(40))));

    public static final class_1792 MAGICITE_LEGGINGS = registerItem("magicite_leggings",
            new class_1738(ModArmorMaterials.MAGICITE_DUST,
                    class_1738.class_8051.field_41936,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41936.method_56690(40))));

    // BOSS ARMOR
    public static final class_1792 BOSS_CROWN = registerItem("boss_crown",
            new class_1738(ModArmorMaterials.BOSS_ARMOR,
                    class_1738.class_8051.field_41934,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41934.method_56690(50))));

    public static final class_1792 BOSS_BOOTS = registerItem("boss_boots",
            new class_1738(ModArmorMaterials.BOSS_ARMOR,
                    class_1738.class_8051.field_41937,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41937.method_56690(50))));

    public static final class_1792 BOSS_CHESTPLATE = registerItem("boss_chestplate",
            new class_1738(ModArmorMaterials.BOSS_ARMOR,
                    class_1738.class_8051.field_41935,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41935.method_56690(50))));

    public static final class_1792 BOSS_LEGGINGS = registerItem("boss_leggings",
            new class_1738(ModArmorMaterials.BOSS_ARMOR,
                    class_1738.class_8051.field_41936,
                    new class_1792.class_1793().method_7895(class_1738.class_8051.field_41936.method_56690(50))));

    public static final class_1792 ANCIENT_GEMSTONE = registerItem("ancient_gemstone", new class_1792(new class_1792.class_1793()));
    public static final class_1792 ANCIENT_GEMSTONE_DUST = registerItem("ancient_gemstone_dust", new class_1792(new class_1792.class_1793()));
    public static final class_1792 PILLAGERITE = registerItem("pillagerite", new class_1792(new class_1792.class_1793()));
    public static final class_1792 PILLAGERITE_INGOT = registerItem("pillagerite_ingot", new class_1792(new class_1792.class_1793()));
    public static final class_1792 MAGICITE = registerItem("magicite", new class_1792(new class_1792.class_1793()));
    public static final class_1792 MAGICITE_DUST = registerItem("magicite_dust", new class_1792(new class_1792.class_1793()));


    // ROWAN WOOD SIGNS
    public static final class_1792 ROWAN_SIGN = registerItem("rowan_sign",
            new class_1822(new class_1792.class_1793().method_7889(16), ModBlocks.STANDING_ROWAN_SIGN, ModBlocks.WALL_ROWAN_SIGN));
    public static final class_1792 HANGING_ROWAN_SIGN = registerItem("rowan_hanging_sign",
            new class_1822(new class_1792.class_1793().method_7889(16), ModBlocks.HANGING_ROWAN_SIGN, ModBlocks.WALL_HANGING_ROWAN_SIGN));

    // JUNIPER WOOD
    public static final class_1792 ROWAN_BOAT = TerraformBoatItemHelper.registerBoatItem(ModBoats.ROWAN_BOAT_ID, ModBoats.ROWAN_BOAT_KEY, false);
    public static final class_1792 ROWAN_CHEST_BOAT = TerraformBoatItemHelper.registerBoatItem(ModBoats.ROWAN_CHEST_BOAT_ID, ModBoats.ROWAN_BOAT_KEY, true);



    // JUNIPER WOOD SIGNS
    public static final class_1792 JUNIPER_SIGN = registerItem("juniper_sign",
            new class_1822(new class_1792.class_1793().method_7889(16), ModBlocks.STANDING_JUNIPER_SIGN, ModBlocks.WALL_JUNIPER_SIGN));
    public static final class_1792 HANGING_JUNIPER_SIGN = registerItem("juniper_hanging_sign",
            new class_1822(new class_1792.class_1793().method_7889(16), ModBlocks.HANGING_JUNIPER_SIGN, ModBlocks.WALL_HANGING_JUNIPER_SIGN));

    // JUNIPER WOOD
    public static final class_1792 JUNIPER_BOAT = TerraformBoatItemHelper.registerBoatItem(ModBoats.JUNIPER_BOAT_ID, ModBoats.JUNIPER_BOAT_KEY, false);
    public static final class_1792 JUNIPER_CHEST_BOAT = TerraformBoatItemHelper.registerBoatItem(ModBoats.JUNIPER_CHEST_BOAT_ID, ModBoats.JUNIPER_BOAT_KEY, true);



    // SYCAMORE WOOD SIGNS
    public static final class_1792 SYCAMORE_SIGN = registerItem("sycamore_sign",
            new class_1822(new class_1792.class_1793().method_7889(16), ModBlocks.STANDING_SYCAMORE_SIGN, ModBlocks.WALL_SYCAMORE_SIGN));
    public static final class_1792 HANGING_SYCAMORE_SIGN = registerItem("sycamore_hanging_sign",
            new class_1822(new class_1792.class_1793().method_7889(16), ModBlocks.HANGING_SYCAMORE_SIGN, ModBlocks.WALL_HANGING_SYCAMORE_SIGN));

    // SYCAMORE WOOD
    public static final class_1792 SYCAMORE_BOAT = TerraformBoatItemHelper.registerBoatItem(ModBoats.SYCAMORE_BOAT_ID, ModBoats.SYCAMORE_BOAT_KEY, false);
    public static final class_1792 SYCAMORE_CHEST_BOAT = TerraformBoatItemHelper.registerBoatItem(ModBoats.SYCAMORE_CHEST_BOAT_ID, ModBoats.SYCAMORE_BOAT_KEY, true);

    // SPAWN EGGS
    public static final class_1792 ORANGE_KOI_FISH_SPAWN_EGG = registerItem("orange_koi_fish_spawn_egg",
            new class_1826(ModEntities.ORANGE_KOI_FISH, 0xffffff, 0xf37800, new class_1792.class_1793()));
    public static final class_1792 WHITE_KOI_FISH_SPAWN_EGG = registerItem("white_koi_fish_spawn_egg",
            new class_1826(ModEntities.WHITE_KOI_FISH, 0xffffff, 0xFAF9F6, new class_1792.class_1793()));
    public static final class_1792 BLACK_KOI_FISH_SPAWN_EGG = registerItem("black_koi_fish_spawn_egg",
            new class_1826(ModEntities.BLACK_KOI_FISH, 0xffffff, 0x000000, new class_1792.class_1793()));
    public static final class_1792 PILLAGER_BRUTE_BOSS_SPAWN_EGG = registerItem("pillager_brute_boss_spawn_egg",
            new class_1826(ModEntities.PILLAGER_BRUTE_BOSS, 0xa4a8b8, 0x194723, new class_1792.class_1793()));
    public static final class_1792 MONARCH_BUTTERFLY_SPAWN_EGG = registerItem("monarch_butterfly_spawn_egg",
            new class_1826(ModEntities.MONARCHBUTTERFLY, 0xc66b3d, 0x201e20, new class_1792.class_1793()));
    public static final class_1792 EVIL_VILLAGER_BOSS_SPAWN_EGG = registerItem("evil_villager_boss_spawn_egg",
            new class_1826(ModEntities.EVIL_VILLAGER_BOSS, 0x1b6535, 0xb9925e, new class_1792.class_1793()));
    public static final class_1792 PILLAGER_WIZARD_BOSS_SPAWN_EGG = registerItem("pillager_wizard_boss_spawn_egg",
            new class_1826(ModEntities.PILLAGER_WIZARD_BOSS, 0x5b6135, 0xd9925e, new class_1792.class_1793()));



    // KOI BUCKET ITEMS
    public static final class_1792 BLACK_KOI_BUCKET = registerItem("black_koi_bucket",
            new class_1785(ModEntities.BLACK_KOI_FISH, class_3612.field_15910, class_3417.field_14563, new class_1792.class_1793().method_7889(1)));
    public static final class_1792 ORANGE_KOI_BUCKET = registerItem("orange_koi_bucket",
            new class_1785(ModEntities.ORANGE_KOI_FISH, class_3612.field_15910, class_3417.field_14563, new class_1792.class_1793().method_7889(1)));
    public static final class_1792 WHITE_KOI_BUCKET = registerItem("white_koi_bucket",
            new class_1785(ModEntities.WHITE_KOI_FISH, class_3612.field_15910, class_3417.field_14563, new class_1792.class_1793().method_7889(1)));

    // BERRIES
    public static final class_1792 JUNIPER_BERRIES = registerItem( "juniper_berries", new class_1792(new class_1792.class_1793().method_19265(ModFoodComponent.JUNIPER_BERRIES)));
    public static final class_1792 ROWAN_BERRIES = registerItem( "rowan_berries", new class_1792(new class_1792.class_1793().method_19265(ModFoodComponent.ROWAN_BERRIES)));

    // JUNIPER BREAD
    public static final class_1792 JUNIPER_BREAD = registerItem( "juniper_bread", new class_1792(new class_1792.class_1793().method_19265(ModFoodComponent.JUNIPER_BREAD)));

    // JUNIPER FLOUR
    public static final class_1792 JUNIPER_FLOUR = registerItem("juniper_flour", new class_1792(new class_1792.class_1793()));

    // Once an item has been made, you have to add it to a group
    private static void addItemsToIngredientTabItemGroup(FabricItemGroupEntries entries){
    }

    private static class_1792 registerItem(String name, class_1792 item){
        return class_2378.method_10230(class_7923.field_41178, class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, name), item);
    }

    public static void registerModItems(){
        MinecraftVillagerDimensionMod.LOGGER.info("Registering Mod Items for " + MinecraftVillagerDimensionMod.MOD_ID);

        ItemGroupEvents.modifyEntriesEvent(class_7706.field_41062).register(ModItems::addItemsToIngredientTabItemGroup);
    }
}
