package net.scott.minecraftvillagerdimensionmod.particle;

import net.fabricmc.api.EnvType;
import net.fabricmc.api.Environment;
import net.minecraft.class_2400;
import net.minecraft.class_3532;
import net.minecraft.class_3999;
import net.minecraft.class_4002;
import net.minecraft.class_4955;
import net.minecraft.class_638;
import net.minecraft.class_703;
import net.minecraft.class_707;
import net.minecraft.client.particle.*;

public class EmeraldFlame extends class_4955 {
    EmeraldFlame(class_638 clientWorld, double d, double e, double f, double g, double h, double i) {
        super(clientWorld, d, e, f, g, h, i);
    }

    @Override
    public class_3999 method_18122() {
        return class_3999.field_17828;
    }

    @Override
    public void method_3069(double dx, double dy, double dz) {
        this.method_3067(this.method_3064().method_989(dx, dy, dz));
        this.method_3072();
    }

    @Override
    public float method_18132(float tickDelta) {
        float f = ((float)this.field_3866 + tickDelta) / (float)this.field_3847;
        return this.field_17867 * (1.0F - f * f * 0.5F);
    }

    @Override
    public int method_3068(float tint) {
        float f = ((float)this.field_3866 + tint) / (float)this.field_3847;
        f = class_3532.method_15363(f, 0.0F, 1.0F);
        int i = super.method_3068(tint);
        int j = i & 0xFF;
        int k = i >> 16 & 0xFF;
        j += (int)(f * 15.0F * 16.0F);
        if (j > 240) {
            j = 240;
        }

        return j | k << 16;
    }

    @Environment(EnvType.CLIENT)
    public static class Factory implements class_707<class_2400> {
        private final class_4002 spriteProvider;

        public Factory(class_4002 spriteProvider) {
            this.spriteProvider = spriteProvider;
        }

        public class_703 createParticle(class_2400 simpleParticleType, class_638 clientWorld, double d, double e, double f, double g, double h, double i) {
            EmeraldFlame flameParticle = new EmeraldFlame(clientWorld, d, e, f, g, h, i);
            flameParticle.method_18140(this.spriteProvider);
            return flameParticle;
        }
    }

    @Environment(EnvType.CLIENT)
    public static class SmallFactory implements class_707<class_2400> {
        private final class_4002 spriteProvider;

        public SmallFactory(class_4002 spriteProvider) {
            this.spriteProvider = spriteProvider;
        }

        public class_703 createParticle(class_2400 simpleParticleType, class_638 clientWorld, double d, double e, double f, double g, double h, double i) {
            EmeraldFlame flameParticle = new EmeraldFlame(clientWorld, d, e, f, g, h, i);
            flameParticle.method_18140(this.spriteProvider);
            flameParticle.method_3087(0.5F);
            return flameParticle;
        }
    }
}
