package net.scott.minecraftvillagerdimensionmod.world.biome;

import net.minecraft.class_1143;
import net.minecraft.class_1299;
import net.minecraft.class_1311;
import net.minecraft.class_1959;
import net.minecraft.class_2893;
import net.minecraft.class_2960;
import net.minecraft.class_3417;
import net.minecraft.class_3864;
import net.minecraft.class_4763;
import net.minecraft.class_4968;
import net.minecraft.class_5321;
import net.minecraft.class_5483;
import net.minecraft.class_5485;
import net.minecraft.class_6814;
import net.minecraft.class_6819;
import net.minecraft.class_7891;
import net.minecraft.class_7924;
import net.minecraft.world.gen.feature.*;
import net.scott.minecraftvillagerdimensionmod.MinecraftVillagerDimensionMod;
import net.scott.minecraftvillagerdimensionmod.world.ModPlacedFeatures;


public class ModBiomes {
    public static final class_5321<class_1959> VILLAGER_BIOME = class_5321.method_29179(class_7924.field_41236,
            class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "villager_biome"));

    public static final class_5321<class_1959> PILLAGER_BIOME = class_5321.method_29179(class_7924.field_41236,
            class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "pillager_biome"));

    public static final class_5321<class_1959> CONTESTED_BIOME = class_5321.method_29179(class_7924.field_41236,
            class_2960.method_60655(MinecraftVillagerDimensionMod.MOD_ID, "contested_biome"));

    public static void bootstrap(class_7891<class_1959> context){
        context.method_46838(VILLAGER_BIOME, villagerBiome(context));
        context.method_46838(PILLAGER_BIOME, pillagerBiome(context));
        context.method_46838(CONTESTED_BIOME, contestedBiome(context));
    }

    public static void globalOverworldGeneration(class_5485.class_5495 builder) {
        class_3864.method_16983(builder);
        class_3864.method_32236(builder);
        class_3864.method_17004(builder);
        class_3864.method_17005(builder);
        class_3864.method_16996(builder);
        class_3864.method_16999(builder);
    }

    public static class_1959 villagerBiome(class_7891<class_1959> context) {
        class_5483.class_5496 spawnBuilder = new class_5483.class_5496();

        spawnBuilder.method_31011(class_1311.field_6294, new class_5483.class_1964(class_1299.field_6055, 5, 4, 4));

        class_3864.method_30580(spawnBuilder);
        class_3864.method_30581(spawnBuilder);

        class_5485.class_5495 biomeBuilder =
                new class_5485.class_5495(context.method_46799(class_7924.field_41245),
                        context.method_46799(class_7924.field_41238));

        globalOverworldGeneration(biomeBuilder);
        class_3864.method_17012(biomeBuilder);
        class_3864.method_38568(biomeBuilder);
        class_3864.method_17007(biomeBuilder);

        biomeBuilder.method_30992(class_2893.class_2895.field_13178, ModPlacedFeatures.SYCAMORE_TREE_KEY);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36143);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36139);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36129);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36166);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36182);


        class_3864.method_16970(biomeBuilder);
        class_3864.method_17013(biomeBuilder);
        class_3864.method_16979(biomeBuilder);
        class_3864.method_16982(biomeBuilder);
        class_3864.method_16984(biomeBuilder);
        class_3864.method_16991(biomeBuilder);
        class_3864.method_16992(biomeBuilder);

        return new class_1959.class_1960()
                .method_48164(true)
                .method_8727(0.4f)
                .method_8747(0.7f)
                .method_30973(biomeBuilder.method_46671())
                .method_30974(spawnBuilder.method_31007())
                .method_24379((new class_4763.class_4764())
                        .method_24395(0x506cf0)
                        .method_24397(0x506cf0)
                        .method_30820(0x68bcd8)
                        .method_30822(0x74a749)
                        .method_30821(0x70ae3b)
                        .method_24392(0x569cb3)
                        .method_24943(class_4968.field_23146)
                        .method_27346(class_1143.method_27283(class_3417.field_44693)).method_24391())
                .method_30972();
    }

    public static class_1959 pillagerBiome(class_7891<class_1959> context) {
        class_5483.class_5496 spawnBuilder = new class_5483.class_5496();

        spawnBuilder.method_31011(class_1311.field_6294, new class_5483.class_1964(class_1299.field_6055, 5, 4, 4));

        class_3864.method_30580(spawnBuilder);
        class_3864.method_30581(spawnBuilder);

        class_5485.class_5495 biomeBuilder =
                new class_5485.class_5495(context.method_46799(class_7924.field_41245),
                        context.method_46799(class_7924.field_41238));

        globalOverworldGeneration(biomeBuilder);
        class_3864.method_17012(biomeBuilder);
        class_3864.method_38568(biomeBuilder);
        class_3864.method_17007(biomeBuilder);

        biomeBuilder.method_30992(class_2893.class_2895.field_13178, ModPlacedFeatures.ROWAN_TREE_KEY);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36143);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36136);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36166);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36182);

        class_3864.method_17013(biomeBuilder);
        class_3864.method_16979(biomeBuilder);
        class_3864.method_16982(biomeBuilder);
        class_3864.method_16984(biomeBuilder);
        class_3864.method_16991(biomeBuilder);
        class_3864.method_16992(biomeBuilder);

        return new class_1959.class_1960()
                .method_48164(true)
                .method_8727(0.4f)
                .method_8747(0.7f)
                .method_30973(biomeBuilder.method_46671())
                .method_30974(spawnBuilder.method_31007())
                .method_24379((new class_4763.class_4764())
                        .method_24395(0x506cf0)
                        .method_24397(0x506cf0)
                        .method_30820(0x053671)
                        .method_30822(0x74a749)
                        .method_30821(0x70ae3b)
                        .method_24392(0x1c569b)
                        .method_24943(class_4968.field_23146)
                        .method_27346(class_1143.method_27283(class_3417.field_44693)).method_24391())
                .method_30972();
    }

    public static class_1959 contestedBiome(class_7891<class_1959> context) {
        class_5483.class_5496 spawnBuilder = new class_5483.class_5496();

        spawnBuilder.method_31011(class_1311.field_6294, new class_5483.class_1964(class_1299.field_6055, 5, 4, 4));

        class_3864.method_30580(spawnBuilder);
        class_3864.method_30581(spawnBuilder);

        class_5485.class_5495 biomeBuilder =
                new class_5485.class_5495(context.method_46799(class_7924.field_41245),
                        context.method_46799(class_7924.field_41238));

        globalOverworldGeneration(biomeBuilder);
        class_3864.method_38568(biomeBuilder);
        class_3864.method_17007(biomeBuilder);

        // Adding gravel and sand patches in water only
        biomeBuilder.method_30992(class_2893.class_2895.field_13179, class_6814.field_36011);
        biomeBuilder.method_30992(class_2893.class_2895.field_13179, class_6814.field_36010);
        biomeBuilder.method_30992(class_2893.class_2895.field_13179, class_6814.field_36009);

        biomeBuilder.method_30992(class_2893.class_2895.field_13178, ModPlacedFeatures.JUNIPER_TREE_KEY);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36165);
        biomeBuilder.method_30992(class_2893.class_2895.field_13178, class_6819.field_36182);

        class_3864.method_16979(biomeBuilder);
        class_3864.method_16984(biomeBuilder);
        class_3864.method_16991(biomeBuilder);
        class_3864.method_16992(biomeBuilder);

        return new class_1959.class_1960()
                .method_48164(true)
                .method_8727(0.4f)
                .method_8747(0.7f)
                .method_30973(biomeBuilder.method_46671())
                .method_30974(spawnBuilder.method_31007())
                .method_24379((new class_4763.class_4764())
                        .method_24395(0x506cf0)
                        .method_24397(0x506cf0)
                        .method_30820(0xe8f6dc)//86eef5
                        .method_30822(0x96a853)//74a749
                        .method_30821(0x96a853)//70ae3b
                        .method_24392(0xc1cbb8)//506cf0
                        .method_24943(class_4968.field_23146)
                        .method_27346(class_1143.method_27283(class_3417.field_44693)).method_24391())
                .method_30972();
    }
}
